//----------------------------------------------------------------------
// Tv      : videoInputCupLv`Tv
// File Name : Main.cpp
// Library   :	OpenCV for MS-Windows 1.1
//				http://sourceforge.net/projects/opencvlibrary/
//				videoInput Library 0.1995
//				http://muonics.net/school/spring05/videoInput/
// Author    : dandelion
// Date      : Aug 29, 2009; 22:10
//----------------------------------------------------------------------

#include <iostream>
#include <cstdlib>

//wb_CN[h(OpenCV֘A)
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

//wb_CN[h(videoInput Library֘A)
#include "videoInput.h"

using namespace std;

//Cuǂݍ(OpenCV֘A)
#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")

//Cuǂݍ(videoInput Library֘A)
#pragma comment(lib,"videoInput.lib")

//萔
#define CAPTURE_WIDTH		320	//Lv`TCY()
#define CAPTURE_HEIGHT		240	//Lv`TCY()
#define CAPTURE_FRAMERATE	30	//t[[g

int main(void)
{
	int device1 = 0;
	int key = 0;

	//Lv`摜
	IplImage *image = cvCreateImage(cvSize(CAPTURE_WIDTH, CAPTURE_HEIGHT), IPL_DEPTH_8U, 3);

	//EBhE
	char* window_name = "Capture using videoInput Library";
	cvNamedWindow(window_name,  CV_WINDOW_AUTOSIZE);

	//videoInputIuWFNg
	videoInput VI;

	//p\ȃLv`foCX擾
	int numDevices = VI.listDevices();

	//Lv`foCXȂI
	if(numDevices == 0)
	{
		cerr << "[Error] Capture device not found!!" << endl;
		exit(-1);
	}

	//t[[gݒ
	VI.setIdealFramerate(device1, CAPTURE_FRAMERATE);

	//foCXił̓foCXID = 0CCAPTURE_WIDTH x CAPTURE_HEIGHTŃLv`j
	VI.setupDevice(device1, CAPTURE_WIDTH, CAPTURE_HEIGHT);

	//ESCL[܂ŃLv`𑱂
	while(key != 0x1b)
	{
		image->imageData = (char *)VI.getPixels(device1, false, true);

		//摜\
		cvShowImage(window_name, image);

		//L[
		key = cvWaitKey(1);
	}

	//㏈
	VI.stopDevice(device1);
	cvDestroyWindow(window_name);
	cvReleaseImage(&image);

	return 0;
}